//+------------------------------------------------------------------+
//|                                              Closed cycle FI.mq4 |
//|                                 Copyright  2013, Koval Anatoliy |
//|                       property link "http://pro-forexinform.ru/" |
//+------------------------------------------------------------------+
#property indicator_chart_window

extern string TimeFrame = "H4"; //  
extern int Bar_Number = 6; //  

extern string str1 = "-----  -----";
extern string Symbol_1 = "EUR"; //  #1
extern string Symbol_2 = "USD"; //  #2
extern string Symbol_3 = "GBP"; //  #3
extern string Symbol_4 = "AUD"; //  #4
extern string Symbol_5 = "JPY"; //  #5
extern string Symbol_6 = "NZD"; //  #6
extern string Symbol_7 = "CAD"; //  #7

extern string str2 = "-----   -----";
extern bool Set_Info = true; //    
extern int Corner = 0; //  ,    
                       // 0 -  
                       // 1 -  
                       // 2 -  
                       // 3 -  
extern string Font = "Times New Roman"; //  
extern int FontSize = 12; //  
extern color FontColor_Up = Aqua; //       
extern color FontColor_Dn = Red; //    
extern int Y = 35; //       

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   TFdefin();
   Set_Symbols();
   return(0);
}

int deinit()
{
   ObjDeleteAll();
   return(0);
}

int TF;
string Symbl[8];
int Symbol_Quan, Result[8];

int start()
{
   int i, j;
   string symbl;

   ArrayInitialize(Result, 0);

   for(i=1; i<=Symbol_Quan; i++)
   {
      for(j=1; j<=Symbol_Quan; j++)
      {
         if(i==j)
         {
            continue;
         }
         
         symbl=Symbl[i] + Symbl[j];
         Result[i]=Result[i]+Symbol_Result(symbl);
         
         symbl=Symbl[j] + Symbl[i];
         Result[i]=Result[i]-Symbol_Result(symbl);
      }
   }

   Set_Info();

   return(0);
}

int Symbol_Result(string symbl)
{
   int res;
   double pBid=MarketInfo(symbl, MODE_BID);
   double op=iOpen(symbl, TF, Bar_Number-1);
   double point=MarketInfo(symbl, MODE_POINT);
   
   if(point>0)
   {
      res=NormalizeDouble((pBid-op)/point, 0);
   }
   
   return(res);
}

//+-------------------------------------------------------------------------+
//|         |
//+-------------------------------------------------------------------------+
void TFdefin()
{
   if(TimeFrame=="M1" || TimeFrame=="1") TF=1;
   if(TimeFrame=="M5" || TimeFrame=="5") TF=5;
   if(TimeFrame=="M15" || TimeFrame=="15") TF=15;
   if(TimeFrame=="M30" || TimeFrame=="30") TF=30;
   if(TimeFrame=="H1" || TimeFrame=="1") TF=60;
   if(TimeFrame=="H4" || TimeFrame=="4") TF=240;
   if(TimeFrame=="D1") TF=1440;
   if(TimeFrame=="W1") TF=10080;
   if(TimeFrame=="MN1") TF=43200;
}

void Set_Info()
{
   string name, data, str;
   int i, y;
   color clor;

   ObjDeleteAll();

   for(i=1; i<=Symbol_Quan; i++)
   {
      if(Symbl[i]=="")
      {
         break;
      }
      
      y=y+Y;
      name="Ind_" + Symbl[i];
      data=Symbl[i] + " = " + DoubleToStr(Result[i], 0);
      
      if(Result[i]>=0)
      {
         clor=FontColor_Up;
      }
      else
      {
         clor=FontColor_Dn;
      }
      
      DrowInfo(name, data, 5, y, clor);
   }
}

void DrowInfo(string name, string data, int x, int y, color colr)
{
   ObjectCreate(name, OBJ_LABEL, 0, 0, 0);
   ObjectSet(name, OBJPROP_CORNER, Corner);
   ObjectSet(name, OBJPROP_XDISTANCE, x);
   ObjectSet(name, OBJPROP_YDISTANCE, y);
   ObjectSetText(name, data, FontSize, Font, colr);
}

void ObjDeleteAll()
{
   int i;
   
   if(IsTesting()==true && IsVisualMode()==false)
   {
      return(0);
   }
   
   for(i=0; i<ObjectsTotal(); i++)
   {
      if(StringFind(ObjectName(i), "Ind", 0)>-1)
      {
         ObjectDelete(ObjectName(i));
         i--;
      }
   } 
}

void Set_Symbols()
{
   Symbol_Quan=0;
   
   if(Symbl[1]!="")
   {
      Symbol_Quan++;
      Symbl[Symbol_Quan]=Symbol_1;
   }
   
   if(Symbl[2]!="")
   {
      Symbol_Quan++;
      Symbl[Symbol_Quan]=Symbol_2;
   }

   if(Symbl[3]!="")
   {
      Symbol_Quan++;
      Symbl[Symbol_Quan]=Symbol_3;
   }

   if(Symbl[4]!="")
   {
      Symbol_Quan++;
      Symbl[Symbol_Quan]=Symbol_4;
   }

   if(Symbl[5]!="")
   {
      Symbol_Quan++;
      Symbl[Symbol_Quan]=Symbol_5;
   }

   if(Symbl[6]!="")
   {
      Symbol_Quan++;
      Symbl[Symbol_Quan]=Symbol_6;
   }

   if(Symbl[7]!="")
   {
      Symbol_Quan++;
      Symbl[Symbol_Quan]=Symbol_7;
   }
}

